*** src/backend/utils/adt/numutils.c.orig	Fri Sep 11 11:48:56 1998
--- src/backend/utils/adt/numutils.c	Fri Sep 11 12:02:39 1998
***************
*** 55,62 ****
  
  	Assert(s);
  
! 	errno = 0;
! 	l = strtol(s, &badp, 10);
  	if (errno)					/* strtol must set ERANGE */
  		elog(ERROR, "pg_atoi: error reading \"%s\": %m", s);
  	if (badp && *badp && (*badp != c))
--- 55,73 ----
  
  	Assert(s);
  
!   	errno = 0;
! 
! 	/*
! 	 * Some versions of strtol treat the empty string as an error.  This
! 	 * code will explicitly return 0 for an empty string.
! 	 */
! 
! 	if (s == (char *)NULL)
! 		elog(ERROR, "pg_atoi: NULL pointer!");
! 	else if (*s == 0)
! 		l = (long)0;
! 	else
! 		l = strtol(s, &badp, 10);
  	if (errno)					/* strtol must set ERANGE */
  		elog(ERROR, "pg_atoi: error reading \"%s\": %m", s);
  	if (badp && *badp && (*badp != c))
